package org.qatools.remote;

import java.util.List;

import org.apache.log4j.Logger;
import org.qatools.util.QAToolsUtil;

public abstract class ARemoteAppUtil extends QAToolsUtil {
    private static Logger sLogger = Logger.getLogger(ARemoteAppUtil.class);

    // ------------------------------------------------------
    // ----- variables -------------------------------------
    // ------------------------------------------------------

    // timeout
    private int cTimeoutStart = 60;
    private int cTimeoutShutdown = 60;
    private int cTimeoutKill = 60;

    //required
    private List<RemoteConn> cServerList;
    private String cStartCommand;
    private String cShutdownCommand;
    private String cIsProcessRunningCommand;
    
    //optional
    private List<RemoteFile> cLogFileList = null;
    private String cKillCommand = null;
    
    
    // ------------------------------------------------------
    // ----- constructors -----------------------------------
    // ------------------------------------------------------

    /**
     * Requires connecton to a database
     */
    public ARemoteAppUtil(
    		List<RemoteConn> remoteConnections,
    		String startCommand,
    		String shutdownCommand,
    		String isProcessRunningCommand    		
    		) {
    	
        cServerList = remoteConnections;
        cStartCommand = startCommand;
        cShutdownCommand = shutdownCommand;
        cIsProcessRunningCommand = isProcessRunningCommand;    	
    }



    //TODO - start, shutdown, recycle, kill, isRunning, clearLogs

    
    // ------------------------------------------------------
    // ----- getter / setters -------------------------------
    // ------------------------------------------------------

    public int getTimeoutStart() {
		return cTimeoutStart;
	}


	public void setTimeoutStart(int cTimeoutStart) {
		this.cTimeoutStart = cTimeoutStart;
	}


	public int getTimeoutShutdown() {
		return cTimeoutShutdown;
	}


	public void setTimeoutShutdown(int cTimeoutShutdown) {
		this.cTimeoutShutdown = cTimeoutShutdown;
	}


	public int getTimeoutKill() {
		return cTimeoutKill;
	}


	public void setTimeoutKill(int cTimeoutKill) {
		this.cTimeoutKill = cTimeoutKill;
	}


	public List<RemoteConn> getServerList() {
		return cServerList;
	}


	public void setServerList(List<RemoteConn> cServerList) {
		this.cServerList = cServerList;
	}


	public String getStartCommand() {
		return cStartCommand;
	}


	public void setStartCommand(String cStartCommand) {
		this.cStartCommand = cStartCommand;
	}


	public String getShutdownCommand() {
		return cShutdownCommand;
	}


	public void setShutdownCommand(String cShutdownCommand) {
		this.cShutdownCommand = cShutdownCommand;
	}


	public String getIsProcessRunningCommand() {
		return cIsProcessRunningCommand;
	}


	public void setIsProcessRunningCommand(String cIsProcessRunningCommand) {
		this.cIsProcessRunningCommand = cIsProcessRunningCommand;
	}


	public List<RemoteFile> getLogFileList() {
		return cLogFileList;
	}


	public void setLogFileList(List<RemoteFile> cLogFileList) {
		this.cLogFileList = cLogFileList;
	}


	public String getKillCommand() {
		return cKillCommand;
	}


	public void setKillCommand(String cKillCommand) {
		this.cKillCommand = cKillCommand;
	}
    
    

}
